<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>polylib: arithmetique.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.6 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
<h1>arithmetique.h</h1><a href="include_2polylib_2arithmetique_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/* header file built by cproto */</span>
<a name="l00002"></a>00002 <span class="preprocessor">#ifndef arithmetique_header_included</span>
<a name="l00003"></a>00003 <span class="preprocessor"></span><span class="preprocessor">#define arithmetique_header_included</span>
<a name="l00004"></a>00004 <span class="preprocessor"></span><span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">/** package arithmetique</span>
<a name="l00006"></a>00006 <span class="comment"> *</span>
<a name="l00007"></a>00007 <span class="comment"> * $Id: arithmetique.h,v 1.24 2007/02/22 09:16:57 skimo Exp $</span>
<a name="l00008"></a>00008 <span class="comment"> *</span>
<a name="l00009"></a>00009 <span class="comment"> * Francois Irigoin, mai 1989</span>
<a name="l00010"></a>00010 <span class="comment"> *</span>
<a name="l00011"></a>00011 <span class="comment"> * Modifications</span>
<a name="l00012"></a>00012 <span class="comment"> *  - rewrite of DIVIDE which was wrong (Remi Triolet, Francois Irigoin, </span>
<a name="l00013"></a>00013 <span class="comment"> *    april 90)</span>
<a name="l00014"></a>00014 <span class="comment"> *  - simplification of POSITIVE_DIVIDE by suppressing one modulo</span>
<a name="l00015"></a>00015 <span class="comment"> *  - B.Meister : added addmul, operation existing in gmp and quite useful </span>
<a name="l00016"></a>00016 <span class="comment"> *    (05-2005)</span>
<a name="l00017"></a>00017 <span class="comment"> */</span>
<a name="l00018"></a>00018 
<a name="l00019"></a>00019 <span class="comment">/* We would like linear to be generic about the "integer" type used</span>
<a name="l00020"></a>00020 <span class="comment"> * to represent integer values. Thus Value is defined here. It should</span>
<a name="l00021"></a>00021 <span class="comment"> * be changed to "int" "long" or "long long". In an ideal world,</span>
<a name="l00022"></a>00022 <span class="comment"> * any source modification should be limited to this package.</span>
<a name="l00023"></a>00023 <span class="comment"> *</span>
<a name="l00024"></a>00024 <span class="comment"> * Indeed, we cannot switch easily to bignums that need constructors </span>
<a name="l00025"></a>00025 <span class="comment"> * dans destructors... That would lead to too many modifications...</span>
<a name="l00026"></a>00026 <span class="comment"> * C++ would make things easier and cleaner...</span>
<a name="l00027"></a>00027 <span class="comment"> *</span>
<a name="l00028"></a>00028 <span class="comment"> * Fabien COELHO</span>
<a name="l00029"></a>00029 <span class="comment"> */</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;limits.h&gt;</span>   <span class="comment">/* Included for getting constants: INT_MAX, etc.. */</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef GNUMP</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#include &lt;gmp.h&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#ifndef mp_get_memory_functions</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#if defined(__cplusplus)</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">"C"</span> {
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="keywordtype">void</span> mp_get_memory_functions(
<a name="l00043"></a>00043                 <span class="keywordtype">void</span> *(**alloc_func_ptr) (<span class="keywordtype">size_t</span>),
<a name="l00044"></a>00044                 <span class="keywordtype">void</span> *(**realloc_func_ptr) (<span class="keywordtype">void</span> *, <span class="keywordtype">size_t</span>, <span class="keywordtype">size_t</span>),
<a name="l00045"></a>00045                 <span class="keywordtype">void</span> (**free_func_ptr) (<span class="keywordtype">void</span> *, <span class="keywordtype">size_t</span>));
<a name="l00046"></a>00046 <span class="preprocessor">#if defined(__cplusplus)</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>}
<a name="l00048"></a>00048 <span class="preprocessor">#endif</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#endif </span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>
<a name="l00052"></a>00052 <span class="preprocessor">#ifdef CLN</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00054"></a>00054 <span class="preprocessor">#define WANT_OBFUSCATING_OPERATORS</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#include &lt;cln/cln.h&gt;</span>
<a name="l00056"></a>00056 <span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 <span class="comment">/* </span>
<a name="l00059"></a>00059 <span class="comment">   #        ####   #    #   ####           #        ####   #    #   ####</span>
<a name="l00060"></a>00060 <span class="comment">   #       #    #  ##   #  #    #          #       #    #  ##   #  #    #</span>
<a name="l00061"></a>00061 <span class="comment">   #       #    #  # #  #  #               #       #    #  # #  #  #</span>
<a name="l00062"></a>00062 <span class="comment">   #       #    #  #  # #  #  ###          #       #    #  #  # #  #  ###</span>
<a name="l00063"></a>00063 <span class="comment">   #       #    #  #   ##  #    #          #       #    #  #   ##  #    #</span>
<a name="l00064"></a>00064 <span class="comment">   ######   ####   #    #   ####           ######   ####   #    #   ####</span>
<a name="l00065"></a>00065 <span class="comment">   </span>
<a name="l00066"></a>00066 <span class="comment">*/</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="comment">/* </span>
<a name="l00069"></a>00069 <span class="comment"> * Constants like LONG_LONG_MAX are not defined with ansi options, so they are</span>
<a name="l00070"></a>00070 <span class="comment"> * defined here. </span>
<a name="l00071"></a>00071 <span class="comment"> */</span>  
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="preprocessor">#ifndef LONG_LONG_MAX</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>
<a name="l00075"></a>00075 <span class="comment">/* would fix on solaris:</span>
<a name="l00076"></a>00076 <span class="comment"> * #define LONG_LONG_MAX LLONG_MAX</span>
<a name="l00077"></a>00077 <span class="comment"> * #define LONG_LONG_MIN LLONG_MIN</span>
<a name="l00078"></a>00078 <span class="comment"> */</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#ifndef __LONG_LONG_MAX__</span>
<a name="l00081"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#9bed0d0b1893211f857ad76d6728ea7e">00081</a> <span class="preprocessor"></span><span class="preprocessor">#define __LONG_LONG_MAX__ 9223372036854775807LL</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span><span class="preprocessor">#undef LONG_LONG_MAX</span>
<a name="l00084"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#383fc2c0c24436c812cc22289504a151">00084</a> <span class="preprocessor"></span><span class="preprocessor">#define LONG_LONG_MAX __LONG_LONG_MAX__</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span><span class="preprocessor">#undef LONG_LONG_MIN</span>
<a name="l00086"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#7859270152a7cdc221342c2abdc427fd">00086</a> <span class="preprocessor"></span><span class="preprocessor">#define LONG_LONG_MIN (-LONG_LONG_MAX-1)</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span><span class="preprocessor">#undef ULONG_LONG_MAX</span>
<a name="l00088"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#37ae7009688ff03a821794e036e3e458">00088</a> <span class="preprocessor"></span><span class="preprocessor">#define ULONG_LONG_MAX (LONG_LONG_MAX * 2ULL + 1)</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>
<a name="l00091"></a>00091 <span class="preprocessor">#if defined(LINEAR_VALUE_IS_LONGLONG)</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00093"></a>00093 <span class="preprocessor">#define LINEAR_VALUE_STRING "long long int"</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span><span class="keyword">typedef</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> Value;
<a name="l00095"></a>00095 <span class="preprocessor">#if defined(WIN32) &amp;&amp; !defined(unix)</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>    <span class="comment">/* Mingw or Windows need an incompatible format string. */</span>
<a name="l00097"></a>00097 <span class="preprocessor">#   define VALUE_FMT "%I64d"</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span><span class="preprocessor">#   define VALUE_FMT "%lld"</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_CONST(val) (val##LL) </span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>
<a name="l00103"></a>00103 <span class="comment">/* </span>
<a name="l00104"></a>00104 <span class="comment"> * CAUTION! 'VALUE_MIN' is defined as 'LONG_LONG_MIN +1' so as to preserve the</span>
<a name="l00105"></a>00105 <span class="comment"> * symmetry (-min==max) and to have a NAN value. FC </span>
<a name="l00106"></a>00106 <span class="comment"> */</span> 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="preprocessor">#define VALUE_NAN LONG_LONG_MIN</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MIN (LONG_LONG_MIN+1LL)</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MAX LONG_LONG_MAX</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_SQRT_MIN long_to_value(LONG_MIN) </span>
<a name="l00112"></a>00112 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_SQRT_MAX long_to_value(LONG_MAX)</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ZERO (0LL)</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ONE  (1LL)</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MONE (-1LL)</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
<a name="l00117"></a>00117 <span class="preprocessor">#define VALUE_TO_LONG(val) \</span>
<a name="l00118"></a>00118 <span class="preprocessor">    ((long)((val)&gt;(Value)LONG_MIN&amp;&amp;(val)&lt;=(Value)LONG_MAX)?\</span>
<a name="l00119"></a>00119 <span class="preprocessor">     (val):(THROW(overflow_error), LONG_MIN))</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>
<a name="l00121"></a>00121 <span class="preprocessor">#define VALUE_TO_INT(val) \</span>
<a name="l00122"></a>00122 <span class="preprocessor">    ((int)((val)&gt;(Value)INT_MIN&amp;&amp;(val)&lt;=(Value)INT_MAX)?\</span>
<a name="l00123"></a>00123 <span class="preprocessor">     (val):(THROW(overflow_error), INT_MIN))</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>
<a name="l00125"></a>00125 <span class="preprocessor">#define VALUE_TO_DOUBLE(val) ((double)(val))</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>
<a name="l00127"></a>00127 <span class="comment">/* #define VALUE_TO_FLOAT(val) ((float)(val)): Doesn't seem to work with gcc */</span>
<a name="l00128"></a>00128 <span class="preprocessor">#define VALUE_TO_FLOAT(val) ((float)((int)(val)))</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00130"></a>00130 <span class="comment">/* end LINEAR_VALUE_IS_LONGLONG */</span>
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="comment">/* </span>
<a name="l00133"></a>00133 <span class="comment"> </span>
<a name="l00134"></a>00134 <span class="comment">   #        ####   #    #   ####</span>
<a name="l00135"></a>00135 <span class="comment">   #       #    #  ##   #  #    #</span>
<a name="l00136"></a>00136 <span class="comment">   #       #    #  # #  #  #</span>
<a name="l00137"></a>00137 <span class="comment">   #       #    #  #  # #  #  ###</span>
<a name="l00138"></a>00138 <span class="comment">   #       #    #  #   ##  #    #</span>
<a name="l00139"></a>00139 <span class="comment">   ######   ####   #    #   ####</span>
<a name="l00140"></a>00140 <span class="comment"> </span>
<a name="l00141"></a>00141 <span class="comment">*/</span>
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="preprocessor">#elif defined(LINEAR_VALUE_IS_LONG)</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>
<a name="l00145"></a>00145 <span class="preprocessor">#define LINEAR_VALUE_STRING "long int"</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span><span class="keyword">typedef</span> <span class="keywordtype">long</span> Value;
<a name="l00147"></a>00147 <span class="preprocessor">#define VALUE_FMT "%ld"</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_CONST(val) (val##L)</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_NAN LONG_MIN</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MIN (LONG_MIN+1L)</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MAX LONG_MAX</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_SQRT_MIN int_to_value(INT_MIN)</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_SQRT_MAX int_to_value(INT_MAX)</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ZERO 0L</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ONE  1L</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MONE -1L</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_LONG(val) (val)</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_INT(val) ((int)(val))</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_FLOAT(val) ((float)(val))</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_DOUBLE(val) ((double)(val))</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>
<a name="l00162"></a>00162 <span class="comment">/* end LINEAR_VALUE_IS_LONG */</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="comment">/* </span>
<a name="l00165"></a>00165 <span class="comment">   ######  #        ####     ##     #####</span>
<a name="l00166"></a>00166 <span class="comment">   #       #       #    #   #  #      #</span>
<a name="l00167"></a>00167 <span class="comment">   #####   #       #    #  #    #     #</span>
<a name="l00168"></a>00168 <span class="comment">   #       #       #    #  ######     #</span>
<a name="l00169"></a>00169 <span class="comment">   #       #       #    #  #    #     #</span>
<a name="l00170"></a>00170 <span class="comment">   #       ######   ####   #    #     #</span>
<a name="l00171"></a>00171 <span class="comment"> </span>
<a name="l00172"></a>00172 <span class="comment">*/</span>
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="comment">/*</span>
<a name="l00175"></a>00175 <span class="comment">#elif defined(LINEAR_VALUE_IS_FLOAT)</span>
<a name="l00176"></a>00176 <span class="comment"></span>
<a name="l00177"></a>00177 <span class="comment">#define LINEAR_VALUE_STRING "float"</span>
<a name="l00178"></a>00178 <span class="comment">typedef float Value;</span>
<a name="l00179"></a>00179 <span class="comment">#define VALUE_FMT "%f"</span>
<a name="l00180"></a>00180 <span class="comment">#define VALUE_CONST(val) (val)</span>
<a name="l00181"></a>00181 <span class="comment">#define VALUE_MIN FLOAT_MIN</span>
<a name="l00182"></a>00182 <span class="comment">#define VALUE_MAX FLOAT_MAX</span>
<a name="l00183"></a>00183 <span class="comment">#define VALUE_ZERO 0.0</span>
<a name="l00184"></a>00184 <span class="comment">#define VALUE_ONE  1.0</span>
<a name="l00185"></a>00185 <span class="comment">#define VALUE_MONE -1.0</span>
<a name="l00186"></a>00186 <span class="comment">#define VALUE_TO_LONG(val) ((long)(val))</span>
<a name="l00187"></a>00187 <span class="comment">#define VALUE_TO_INT(val) ((int)(val))</span>
<a name="l00188"></a>00188 <span class="comment">#define VALUE_TO_FLOAT(val) ((float)(val))</span>
<a name="l00189"></a>00189 <span class="comment">#define VALUE_TO_DOUBLE(val) ((double)(val))</span>
<a name="l00190"></a>00190 <span class="comment"></span>
<a name="l00191"></a>00191 <span class="comment">*/</span>
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="comment">/* end LINEAR_VALUE_IS_FLOAT */</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="comment">/*</span>
<a name="l00196"></a>00196 <span class="comment">   ####   #    #    ##    #####           #   #</span>
<a name="l00197"></a>00197 <span class="comment">  #    #  #    #   #  #   #    #           # #</span>
<a name="l00198"></a>00198 <span class="comment">  #       ######  #    #  #    #         #######</span>
<a name="l00199"></a>00199 <span class="comment">  #       #    #  ######  #####            # #</span>
<a name="l00200"></a>00200 <span class="comment">  #    #  #    #  #    #  #   #           #   #</span>
<a name="l00201"></a>00201 <span class="comment">   ####   #    #  #    #  #    #</span>
<a name="l00202"></a>00202 <span class="comment">  </span>
<a name="l00203"></a>00203 <span class="comment">   */</span>
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="comment">/* Char version is used to detect invalid assignments */</span>
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="preprocessor">#elif defined(LINEAR_VALUE_IS_CHARS)</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span>
<a name="l00209"></a>00209 <span class="preprocessor">#define LINEAR_VALUE_STRING "char"</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span><span class="keyword">typedef</span> <span class="keyword">union </span>{ <span class="keywordtype">char</span> *<a class="code" href="polytest_8c.html#27d9a0cff1341bbc004fabd1ad8a1543">s</a>; <span class="keywordtype">long</span> l; <span class="keywordtype">int</span> i; <span class="keywordtype">float</span> f; <span class="keywordtype">double</span> d;} Value;
<a name="l00211"></a>00211 <span class="preprocessor">#define VALUE_FMT "%s"</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_CONST(val) ((Value)(val))</span>
<a name="l00213"></a>00213 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_NAN ((Value)(long)0xdadeebee)</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MIN ((Value)(long)0xdeadbeef)</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MAX ((Value)(long)0xfeedabee)</span>
<a name="l00216"></a>00216 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ZERO ((Value)0)</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ONE  ((Value)1)</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MONE ((Value)-1)</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_LONG(val) (val.l)</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_INT(val) (val.i)</span>
<a name="l00221"></a>00221 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_FLOAT(val) (val.f)</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_DOUBLE(val) (val.d)</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>
<a name="l00224"></a>00224 <span class="comment">/* end LINEAR_VALUE_IS_CHARS */</span>
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="comment">/*</span>
<a name="l00227"></a>00227 <span class="comment">    #    #    #   #####</span>
<a name="l00228"></a>00228 <span class="comment">    #    ##   #     #</span>
<a name="l00229"></a>00229 <span class="comment">    #    # #  #     #</span>
<a name="l00230"></a>00230 <span class="comment">    #    #  # #     #</span>
<a name="l00231"></a>00231 <span class="comment">    #    #   ##     #</span>
<a name="l00232"></a>00232 <span class="comment">    #    #    #     #</span>
<a name="l00233"></a>00233 <span class="comment"></span>
<a name="l00234"></a>00234 <span class="comment">*/</span>
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="preprocessor">#elif defined(LINEAR_VALUE_IS_INT)</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>
<a name="l00238"></a>00238 <span class="preprocessor">#define LINEAR_VALUE_STRING "int"</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span><span class="keyword">typedef</span> <span class="keywordtype">int</span> Value;
<a name="l00240"></a>00240 <span class="preprocessor">#define VALUE_FMT "%d"</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_CONST(val) (val)</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_NAN INT_MIN</span>
<a name="l00243"></a>00243 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MIN (INT_MIN+1)</span>
<a name="l00244"></a>00244 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MAX INT_MAX</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ZERO  0</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_ONE   1</span>
<a name="l00247"></a>00247 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_MONE -1</span>
<a name="l00248"></a>00248 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_LONG(val) ((long)(val))</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_INT(val) ((int)(val))</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_FLOAT(val) ((float)(val))</span>
<a name="l00251"></a>00251 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_DOUBLE(val) ((double)(val))</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>
<a name="l00253"></a>00253 <span class="comment">/* end LINEAR_VALUE_IS_INT */</span>
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="preprocessor">#elif defined(GNUMP)</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>
<a name="l00257"></a>00257 <span class="preprocessor">#define LINEAR_VALUE_STRING "gmp"</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span><span class="keyword">typedef</span> mpz_t Value;
<a name="l00259"></a>00259 <span class="preprocessor">#define VALUE_FMT "%s"</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
<a name="l00261"></a>00261 <span class="comment">/* don't use these, use value_set_si instead ! */</span>
<a name="l00262"></a>00262 <span class="preprocessor">#undef VALUE_ZERO</span>
<a name="l00263"></a>00263 <span class="preprocessor"></span><span class="preprocessor">#undef VALUE_ONE</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span><span class="preprocessor">#undef VALUE_MONE</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_LONG(val) (mpz_get_si(val))</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_INT(val) ((int)mpz_get_si(val))</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_FLOAT(val) ((float)((int)mpz_get_si(val)))</span>
<a name="l00268"></a>00268 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_DOUBLE(val) (mpz_get_d(val))</span>
<a name="l00269"></a>00269 <span class="preprocessor"></span>
<a name="l00270"></a>00270 <span class="preprocessor">#elif defined(CLN)</span>
<a name="l00271"></a>00271 <span class="preprocessor"></span>
<a name="l00272"></a>00272 <span class="preprocessor">#define LINEAR_VALUE_STRING "cln"</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span><span class="keyword">typedef</span> cln::cl_I Value;
<a name="l00274"></a>00274 <span class="preprocessor">#define VALUE_FMT "%s"</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span>
<a name="l00276"></a>00276 <span class="preprocessor">#define VALUE_TO_INT(val) (cln::cl_I_to_int(val))</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span><span class="preprocessor">#define VALUE_TO_DOUBLE(val) (cln::double_approx(val))</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>
<a name="l00279"></a>00279 <span class="preprocessor">#endif </span>
<a name="l00280"></a>00280 <span class="preprocessor"></span>
<a name="l00281"></a>00281 <span class="comment">/* ***************** MACROS FOR MANIPULATING VALUES ******************** */</span>
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 <span class="preprocessor">#if defined(CLN)</span>
<a name="l00284"></a>00284 <span class="preprocessor"></span>
<a name="l00285"></a>00285 <span class="preprocessor">#define value_init(val)         ((val).word = ((cln::cl_uint)cl_FN_tag) &lt;&lt; cl_tag_shift)</span>
<a name="l00286"></a>00286 <span class="preprocessor"></span><span class="preprocessor">#define value_assign(v1,v2)     ((v1) = (v2))</span>
<a name="l00287"></a>00287 <span class="preprocessor"></span><span class="preprocessor">#define value_set_si(val,i)     ((val) = (i))    </span>
<a name="l00288"></a>00288 <span class="preprocessor"></span><span class="preprocessor">#define value_set_double(val,d) ((val) = cln::truncate1(cln::cl_R(d)))</span>
<a name="l00289"></a>00289 <span class="preprocessor"></span><span class="preprocessor">#define value_clear(val)        ((val) = 0)</span>
<a name="l00290"></a>00290 <span class="preprocessor"></span><span class="preprocessor">#define value_read(val,str)     ((val) = (str))</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span><span class="preprocessor">#define value_print(Dst,fmt,val)  {std::ostringstream strm; strm &lt;&lt; val; \</span>
<a name="l00292"></a>00292 <span class="preprocessor">                                   fprintf((Dst),(fmt),strm.str().c_str()); \</span>
<a name="l00293"></a>00293 <span class="preprocessor">                                  }</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span><span class="preprocessor">#define value_swap(v1,v2)          {Value tmp; tmp = v2; \</span>
<a name="l00295"></a>00295 <span class="preprocessor">                                    v2 = v1; v1 = tmp;   \</span>
<a name="l00296"></a>00296 <span class="preprocessor">                                   }</span>
<a name="l00297"></a>00297 <span class="preprocessor"></span>
<a name="l00298"></a>00298 <span class="comment">/* Boolean operators on 'Value' */</span>
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="preprocessor">#define value_eq(v1,v2) ((v1)==(v2))</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span><span class="preprocessor">#define value_ne(v1,v2) ((v1)!=(v2))</span>
<a name="l00302"></a>00302 <span class="preprocessor"></span><span class="preprocessor">#define value_gt(v1,v2) ((v1)&gt;(v2))</span>
<a name="l00303"></a>00303 <span class="preprocessor"></span><span class="preprocessor">#define value_ge(v1,v2) ((v1)&gt;=(v2))</span>
<a name="l00304"></a>00304 <span class="preprocessor"></span><span class="preprocessor">#define value_lt(v1,v2) ((v1)&lt;(v2))</span>
<a name="l00305"></a>00305 <span class="preprocessor"></span><span class="preprocessor">#define value_le(v1,v2) ((v1)&lt;=(v2))</span>
<a name="l00306"></a>00306 <span class="preprocessor"></span>
<a name="l00307"></a>00307 <span class="preprocessor">#define value_abs_eq(v1,v2) (cln::abs(v1)==cln::abs(v2))</span>
<a name="l00308"></a>00308 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_ne(v1,v2) (cln::abs(v1)!=cln::abs(v2))</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_gt(v1,v2) (cln::abs(v1)&gt;cln::abs(v2))</span>
<a name="l00310"></a>00310 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_ge(v1,v2) (cln::abs(v1)&gt;=cln::abs(v2))</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_lt(v1,v2) (cln::abs(v1)&lt;cln::abs(v2))</span>
<a name="l00312"></a>00312 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_le(v1,v2) (cln::abs(v1)&lt;=cln::abs(v2))</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>
<a name="l00314"></a>00314 <span class="preprocessor">#define value_sign(val)      (cln::signum(val))</span>
<a name="l00315"></a>00315 <span class="preprocessor"></span><span class="preprocessor">#define value_compare(v1,v2) (cln::compare((v1),(v2)))</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>
<a name="l00317"></a>00317 <span class="preprocessor">#define value_addto(ref,val1,val2)      ((ref) = (val1)+(val2))</span>
<a name="l00318"></a>00318 <span class="preprocessor"></span><span class="preprocessor">#define value_add_int(ref,val,vint)     ((ref) = (val)+(vint))</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span><span class="preprocessor">#define value_addmul(ref, val1, val2)   ((ref) += (val1)*(val2))</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span><span class="preprocessor">#define value_increment(ref,val)        ((ref) = (val)+1)</span>
<a name="l00321"></a>00321 <span class="preprocessor"></span><span class="preprocessor">#define value_multiply(ref,val1,val2)   ((ref) = (val1)*(val2))</span>
<a name="l00322"></a>00322 <span class="preprocessor"></span><span class="preprocessor">#define value_subtract(ref,val1,val2)   ((ref) = (val1)-(val2))</span>
<a name="l00323"></a>00323 <span class="preprocessor"></span><span class="preprocessor">#define value_sub_int(ref,val1,val2)    ((ref) = (val1)-(val2))</span>
<a name="l00324"></a>00324 <span class="preprocessor"></span><span class="preprocessor">#define value_decrement(ref,val)        ((ref) = (val)-1)</span>
<a name="l00325"></a>00325 <span class="preprocessor"></span><span class="preprocessor">#define value_division(ref,val1,val2)   ((ref) = cln::truncate1(val1,val2))</span>
<a name="l00326"></a>00326 <span class="preprocessor"></span><span class="preprocessor">#define value_divexact(ref,val1,val2)   ((ref) = cln::exquo(val1,val2))</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span><span class="preprocessor">#define value_modulus(ref,val1,val2)    ((ref) = cln::truncate2(val1,val2).remainder)</span>
<a name="l00328"></a>00328 <span class="preprocessor"></span><span class="preprocessor">#define value_pdivision(ref,val1,val2)  ((ref) = cln::floor1(val1,val2))</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span><span class="preprocessor">#define value_pmodulus(ref,val1,val2)   ((ref) = cln::floor2(val1,val2).remainder)</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span><span class="preprocessor">#define value_oppose(ref,val)           ((ref) = -(val))</span>
<a name="l00331"></a>00331 <span class="preprocessor"></span><span class="preprocessor">#define value_absolute(ref,val)         ((ref) = cln::abs(val))</span>
<a name="l00332"></a>00332 <span class="preprocessor"></span><span class="preprocessor">#define value_minimum(ref,val1,val2)    ((ref) = cln::min((val1),(val2)))</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span><span class="preprocessor">#define value_maximum(ref,val1,val2)    ((ref) = cln::max((val1),(val2)))</span>
<a name="l00334"></a>00334 <span class="preprocessor"></span><span class="preprocessor">#define value_gcd(ref,val1,val2)        ((ref) = cln::gcd((val1),(val2)))</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span><span class="preprocessor">#define value_lcm(ref,val1,val2)        ((ref) = cln::lcm((val1),(val2)))</span>
<a name="l00336"></a>00336 <span class="preprocessor"></span><span class="preprocessor">#define value_orto(ref,val1,val2)       ((ref) = (val1)|(val2))</span>
<a name="l00337"></a>00337 <span class="preprocessor"></span><span class="preprocessor">#define value_andto(ref,val1,val2)      ((ref) = (val1)&amp;(val2))</span>
<a name="l00338"></a>00338 <span class="preprocessor"></span>
<a name="l00339"></a>00339 <span class="comment">/* Conditional operations on 'Value' */</span>
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="preprocessor">#define value_pos_p(val)         ((val) &gt;  0)</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span><span class="preprocessor">#define value_neg_p(val)         ((val) &lt;  0)</span>
<a name="l00343"></a>00343 <span class="preprocessor"></span><span class="preprocessor">#define value_posz_p(val)        ((val) &gt;= 0)</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span><span class="preprocessor">#define value_negz_p(val)        ((val) &lt;= 0)</span>
<a name="l00345"></a>00345 <span class="preprocessor"></span><span class="preprocessor">#define value_zero_p(val)        ((val) == 0)</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span><span class="preprocessor">#define value_notzero_p(val)     ((val) != 0)</span>
<a name="l00347"></a>00347 <span class="preprocessor"></span><span class="preprocessor">#define value_one_p(val)         ((val) == 1)</span>
<a name="l00348"></a>00348 <span class="preprocessor"></span><span class="preprocessor">#define value_notone_p(val)      ((val) != 1)</span>
<a name="l00349"></a>00349 <span class="preprocessor"></span><span class="preprocessor">#define value_mone_p(val)        ((val) == -1)</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span><span class="preprocessor">#define value_notmone_p(val)     ((val) != -1)</span>
<a name="l00351"></a>00351 <span class="preprocessor"></span><span class="preprocessor">#define value_cmp_si(val, n)     (cln::compare(val,n))</span>
<a name="l00352"></a>00352 <span class="preprocessor"></span>
<a name="l00353"></a>00353 <span class="preprocessor">#elif defined(GNUMP)</span>
<a name="l00354"></a>00354 <span class="preprocessor"></span>
<a name="l00355"></a>00355 <span class="comment">/* Basic macros */</span>
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="preprocessor">#define value_init(val)        (mpz_init((val)))</span>
<a name="l00358"></a>00358 <span class="preprocessor"></span><span class="preprocessor">#define value_assign(v1,v2)    (mpz_set((v1),(v2)))</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span><span class="preprocessor">#define value_set_si(val,i)    (mpz_set_si((val),(i)))    </span>
<a name="l00360"></a>00360 <span class="preprocessor"></span><span class="preprocessor">#define value_set_double(val,d)(mpz_set_d((val),(d)))</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span><span class="preprocessor">#define value_clear(val)       (mpz_clear((val)))</span>
<a name="l00362"></a>00362 <span class="preprocessor"></span><span class="preprocessor">#define value_read(val,str)    (mpz_set_str((val),(str),10))</span>
<a name="l00363"></a>00363 <span class="preprocessor"></span><span class="keyword">typedef</span> void (*value_print_gmp_free_t)(<span class="keywordtype">void</span> *, size_t);
<a name="l00364"></a>00364 <span class="preprocessor">#define value_print(Dst,fmt,val)  {char *str; \</span>
<a name="l00365"></a>00365 <span class="preprocessor">                                value_print_gmp_free_t gmp_free; \</span>
<a name="l00366"></a>00366 <span class="preprocessor">                                str = mpz_get_str(0,10,(val)); \</span>
<a name="l00367"></a>00367 <span class="preprocessor">                                fprintf((Dst),(fmt),str); \</span>
<a name="l00368"></a>00368 <span class="preprocessor">                                mp_get_memory_functions(NULL, NULL, &amp;gmp_free); \</span>
<a name="l00369"></a>00369 <span class="preprocessor">                                (*gmp_free) (str, strlen(str)+1); \</span>
<a name="l00370"></a>00370 <span class="preprocessor">                              }</span>
<a name="l00371"></a>00371 <span class="preprocessor"></span><span class="preprocessor">#define value_swap(val1,val2) (mpz_swap(val1, val2))</span>
<a name="l00372"></a>00372 <span class="preprocessor"></span>                                             
<a name="l00373"></a>00373 <span class="comment">/* Boolean operators on 'Value' */</span>
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 <span class="preprocessor">#define value_eq(v1,v2) (mpz_cmp((v1),(v2)) == 0)</span>
<a name="l00376"></a>00376 <span class="preprocessor"></span><span class="preprocessor">#define value_ne(v1,v2) (mpz_cmp((v1),(v2)) != 0)</span>
<a name="l00377"></a>00377 <span class="preprocessor"></span><span class="preprocessor">#define value_gt(v1,v2) (mpz_cmp((v1),(v2))  &gt; 0)</span>
<a name="l00378"></a>00378 <span class="preprocessor"></span><span class="preprocessor">#define value_ge(v1,v2) (mpz_cmp((v1),(v2)) &gt;= 0)</span>
<a name="l00379"></a>00379 <span class="preprocessor"></span><span class="preprocessor">#define value_lt(v1,v2) (mpz_cmp((v1),(v2))  &lt; 0)</span>
<a name="l00380"></a>00380 <span class="preprocessor"></span><span class="preprocessor">#define value_le(v1,v2) (mpz_cmp((v1),(v2)) &lt;= 0)</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span>
<a name="l00382"></a>00382 <span class="preprocessor">#define value_abs_eq(v1,v2) (mpz_cmpabs((v1),(v2)) == 0)</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_ne(v1,v2) (mpz_cmpabs((v1),(v2)) != 0)</span>
<a name="l00384"></a>00384 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_gt(v1,v2) (mpz_cmpabs((v1),(v2))  &gt; 0)</span>
<a name="l00385"></a>00385 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_ge(v1,v2) (mpz_cmpabs((v1),(v2)) &gt;= 0)</span>
<a name="l00386"></a>00386 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_lt(v1,v2) (mpz_cmpabs((v1),(v2))  &lt; 0)</span>
<a name="l00387"></a>00387 <span class="preprocessor"></span><span class="preprocessor">#define value_abs_le(v1,v2) (mpz_cmpabs((v1),(v2)) &lt;= 0)</span>
<a name="l00388"></a>00388 <span class="preprocessor"></span>
<a name="l00389"></a>00389 <span class="comment">/* Trian operators on 'Value' */</span>
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 <span class="preprocessor">#define value_sign(val)      (mpz_sgn(val))</span>
<a name="l00392"></a>00392 <span class="preprocessor"></span><span class="preprocessor">#define value_compare(v1,v2) (mpz_cmp((v1),(v2)))</span>
<a name="l00393"></a>00393 <span class="preprocessor"></span>
<a name="l00394"></a>00394 <span class="comment">/* Binary operations on 'Value' */</span>
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 <span class="preprocessor">#define value_addto(ref,val1,val2)     (mpz_add((ref),(val1),(val2)))</span>
<a name="l00397"></a>00397 <span class="preprocessor"></span><span class="preprocessor">#define value_add_int(ref,val,vint)     (mpz_add_ui((ref),(val),(long)(vint)))</span>
<a name="l00398"></a>00398 <span class="preprocessor"></span><span class="preprocessor">#define value_addmul(ref, val1, val2)   (mpz_addmul((ref), (val1), (val2)))</span>
<a name="l00399"></a>00399 <span class="preprocessor"></span><span class="preprocessor">#define value_increment(ref,val)       (mpz_add_ui((ref),(val),1))</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span><span class="preprocessor">#define value_multiply(ref,val1,val2)  (mpz_mul((ref),(val1),(val2)))</span>
<a name="l00401"></a>00401 <span class="preprocessor"></span><span class="preprocessor">#define value_subtract(ref,val1,val2) (mpz_sub((ref),(val1),(val2)))</span>
<a name="l00402"></a>00402 <span class="preprocessor"></span><span class="preprocessor">#define value_sub_int(ref,val,vint)     (mpz_sub_ui((ref),(val),(long)(vint)))</span>
<a name="l00403"></a>00403 <span class="preprocessor"></span><span class="preprocessor">#define value_decrement(ref,val)       (mpz_sub_ui((ref),(val),1))</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span><span class="preprocessor">#define value_division(ref,val1,val2)  (mpz_tdiv_q((ref),(val1),(val2)))</span>
<a name="l00405"></a>00405 <span class="preprocessor"></span><span class="preprocessor">#define value_divexact(ref,val1,val2)  (mpz_divexact((ref),(val1),(val2)))</span>
<a name="l00406"></a>00406 <span class="preprocessor"></span><span class="preprocessor">#define value_modulus(ref,val1,val2)   (mpz_tdiv_r((ref),(val1),(val2)))</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span><span class="preprocessor">#define value_pdivision(ref,val1,val2) (mpz_fdiv_q((ref),(val1),(val2)))</span>
<a name="l00408"></a>00408 <span class="preprocessor"></span><span class="preprocessor">#define value_pmodulus(ref,val1,val2)  (mpz_fdiv_r((ref),(val1),(val2)))</span>
<a name="l00409"></a>00409 <span class="preprocessor"></span><span class="preprocessor">#define value_oppose(ref,val)          (mpz_neg((ref),(val)))</span>
<a name="l00410"></a>00410 <span class="preprocessor"></span><span class="preprocessor">#define value_absolute(ref,val)        (mpz_abs((ref),(val)))</span>
<a name="l00411"></a>00411 <span class="preprocessor"></span><span class="preprocessor">#define value_minimum(ref,val1,val2)   (value_le((val1),(val2)) ?  \</span>
<a name="l00412"></a>00412 <span class="preprocessor">                                        mpz_set((ref),(val1)) :    \</span>
<a name="l00413"></a>00413 <span class="preprocessor">                                        mpz_set((ref),(val2)))  </span>
<a name="l00414"></a>00414 <span class="preprocessor"></span><span class="preprocessor">#define value_maximum(ref,val1,val2)   (value_ge((val1),(val2)) ?  \</span>
<a name="l00415"></a>00415 <span class="preprocessor">                                        mpz_set((ref),(val1)) :    \</span>
<a name="l00416"></a>00416 <span class="preprocessor">                                        mpz_set((ref),(val2)))  </span>
<a name="l00417"></a>00417 <span class="preprocessor"></span><span class="preprocessor">#define value_gcd(ref,val1,val2)        (mpz_gcd(ref,val1,val2))</span>
<a name="l00418"></a>00418 <span class="preprocessor"></span><span class="preprocessor">#define value_lcm(ref,val1,val2)        (mpz_lcm(ref,val1,val2))</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span><span class="preprocessor">#define value_orto(ref,val1,val2)      (mpz_ior((ref),(val1),(val2)))</span>
<a name="l00420"></a>00420 <span class="preprocessor"></span><span class="preprocessor">#define value_andto(ref,val1,val2)     (mpz_and((ref),(val1),(val2)))</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>
<a name="l00422"></a>00422 <span class="comment">/* Conditional operations on 'Value' */</span>
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 <span class="preprocessor">#define value_pos_p(val)         (mpz_sgn(val) &gt;  0)</span>
<a name="l00425"></a>00425 <span class="preprocessor"></span><span class="preprocessor">#define value_neg_p(val)         (mpz_sgn(val) &lt;  0)</span>
<a name="l00426"></a>00426 <span class="preprocessor"></span><span class="preprocessor">#define value_posz_p(val)        (mpz_sgn(val) &gt;= 0)</span>
<a name="l00427"></a>00427 <span class="preprocessor"></span><span class="preprocessor">#define value_negz_p(val)        (mpz_sgn(val) &lt;= 0)</span>
<a name="l00428"></a>00428 <span class="preprocessor"></span><span class="preprocessor">#define value_zero_p(val)        (mpz_sgn(val) == 0)</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span><span class="preprocessor">#define value_notzero_p(val)     (mpz_sgn(val) != 0)</span>
<a name="l00430"></a>00430 <span class="preprocessor"></span><span class="preprocessor">#define value_one_p(val)         (mpz_cmp_si(val,1) == 0)</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span><span class="preprocessor">#define value_notone_p(val)      (mpz_cmp_si(val,1) != 0)</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span><span class="preprocessor">#define value_mone_p(val)        (mpz_cmp_si(val,-1) ==0)</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span><span class="preprocessor">#define value_notmone_p(val)     (mpz_cmp_si(val,-1) !=0)</span>
<a name="l00434"></a>00434 <span class="preprocessor"></span><span class="preprocessor">#define value_cmp_si(val, n)     (mpz_cmp_si(val,n))</span>
<a name="l00435"></a>00435 <span class="preprocessor"></span>
<a name="l00436"></a>00436 <span class="comment">/* ************************************************************************* */</span>
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="preprocessor">#else </span><span class="comment">/* 'Value' set to longlong|long|float|char *|int */</span>                                       
<a name="l00439"></a>00439 <span class="comment">/* Basic Macros */</span>                                  
<a name="l00440"></a>00440 
<a name="l00441"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#f71a2ca0294a19cff0cdcbdcc052ee27">00441</a> <span class="preprocessor">#define value_init(val)            ((val) = 0)</span>
<a name="l00442"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#864613888dc46f15679aa4f63e468f89">00442</a> <span class="preprocessor"></span><span class="preprocessor">#define value_assign(v1,v2)        ((v1)  = (v2))</span>
<a name="l00443"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#8cc56567a4a29271559ac0fd5f6c5bfa">00443</a> <span class="preprocessor"></span><span class="preprocessor">#define value_set_si(val,i)        ((val) = (Value)(i))   </span>
<a name="l00444"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#3a9e8def0399e848b9f715238e2378fa">00444</a> <span class="preprocessor"></span><span class="preprocessor">#define value_set_double(val,d)    ((val) = (Value)(d)) </span>
<a name="l00445"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#b9b282921e85a0527d462d331533d619">00445</a> <span class="preprocessor"></span><span class="preprocessor">#define value_clear(val)           ((val) = 0)</span>
<a name="l00446"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#b8a77ddf3765fd598f31d8ca2ac4705c">00446</a> <span class="preprocessor"></span><span class="preprocessor">#define value_read(val,str)        (sscanf((str),VALUE_FMT,&amp;(val)))</span>
<a name="l00447"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#d34605b56b571830b928b50a74d618b7">00447</a> <span class="preprocessor"></span><span class="preprocessor">#define value_print(Dst,fmt,val)   (fprintf((Dst),(fmt),(val)))</span>
<a name="l00448"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#2ebe6e1a78900fb98fe3fa619cb4a4b7">00448</a> <span class="preprocessor"></span><span class="preprocessor">#define value_swap(v1,v2)          {Value tmp; tmp = v2; \</span>
<a name="l00449"></a>00449 <span class="preprocessor">                                    v2 = v1; v1 = tmp;   \</span>
<a name="l00450"></a>00450 <span class="preprocessor">                                   }</span>
<a name="l00451"></a>00451 <span class="preprocessor"></span><span class="comment">/* Cast to 'Value' */</span>
<a name="l00452"></a>00452 
<a name="l00453"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#0d956b6f81568c91fde5b187d4d520c5">00453</a> <span class="preprocessor">#define int_to_value(i) ((Value)(i))</span>
<a name="l00454"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#f0ef3e800321b1ac16c3682b50952d07">00454</a> <span class="preprocessor"></span><span class="preprocessor">#define long_to_value(l) ((Value)(l))</span>
<a name="l00455"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#60fa6965c4d09e771565d0e1cf7377f3">00455</a> <span class="preprocessor"></span><span class="preprocessor">#define float_to_value(f) ((Value)(f))</span>
<a name="l00456"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#49a9d267ebe6dfee3a1e9d6e8972d1b3">00456</a> <span class="preprocessor"></span><span class="preprocessor">#define double_to_value(d) ((Value)(d))</span>
<a name="l00457"></a>00457 <span class="preprocessor"></span>   
<a name="l00458"></a>00458 <span class="comment">/* Boolean operators on 'Value' */</span>
<a name="l00459"></a>00459 
<a name="l00460"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#aac63aa93e7c9fa23ebcde2dc80a12b9">00460</a> <span class="preprocessor">#define value_eq(v1,v2) ((v1)==(v2))</span>
<a name="l00461"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#8092395b58522bbac9f2c8a1ee14c10c">00461</a> <span class="preprocessor"></span><span class="preprocessor">#define value_ne(v1,v2) ((v1)!=(v2))</span>
<a name="l00462"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#15b0362ff15576108c69c31e5ed0cfeb">00462</a> <span class="preprocessor"></span><span class="preprocessor">#define value_gt(v1,v2) ((v1)&gt;(v2))</span>
<a name="l00463"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#eee525b427bd616a24b5b9feb9a9f02e">00463</a> <span class="preprocessor"></span><span class="preprocessor">#define value_ge(v1,v2) ((v1)&gt;=(v2))</span>
<a name="l00464"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#d87a1fcce82a9885ffd8518f4fba2c0e">00464</a> <span class="preprocessor"></span><span class="preprocessor">#define value_lt(v1,v2) ((v1)&lt;(v2))</span>
<a name="l00465"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#47975ace017981602e1064f98f43f8a7">00465</a> <span class="preprocessor"></span><span class="preprocessor">#define value_le(v1,v2) ((v1)&lt;=(v2))</span>
<a name="l00466"></a>00466 <span class="preprocessor"></span>
<a name="l00467"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#22b43fb8cc50260d0bb946b88ade67a6">00467</a> <span class="preprocessor">#define value_abs_eq(v1,v2) (value_abs(v1)==value_abs(v2))</span>
<a name="l00468"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#669046111316f58e17c7ed91e9c01bd6">00468</a> <span class="preprocessor"></span><span class="preprocessor">#define value_abs_ne(v1,v2) (value_abs(v1)!=value_abs(v2))</span>
<a name="l00469"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#5c21a016e4af04e60e157a4eda74df66">00469</a> <span class="preprocessor"></span><span class="preprocessor">#define value_abs_gt(v1,v2) (value_abs(v1)&gt;value_abs(v2))</span>
<a name="l00470"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#a3d0f8d71cd7e497a1a3773af5ca5418">00470</a> <span class="preprocessor"></span><span class="preprocessor">#define value_abs_ge(v1,v2) (value_abs(v1)&gt;=value_abs(v2))</span>
<a name="l00471"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#7eae65fd61df2cb8af2b9c11c586e029">00471</a> <span class="preprocessor"></span><span class="preprocessor">#define value_abs_lt(v1,v2) (value_abs(v1)&lt;value_abs(v2))</span>
<a name="l00472"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#711d2714f733968859f560c95ba2e7b4">00472</a> <span class="preprocessor"></span><span class="preprocessor">#define value_abs_le(v1,v2) (value_abs(v1)&lt;=value_abs(v2))</span>
<a name="l00473"></a>00473 <span class="preprocessor"></span>
<a name="l00474"></a>00474 <span class="comment">/* Trian operators on 'Value' */</span>
<a name="l00475"></a>00475 
<a name="l00476"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#0b5c341e5cae69bf0078a74dbbbaead0">00476</a> <span class="preprocessor">#define value_sign(v) (value_eq(v,VALUE_ZERO)?0:value_lt(v,VALUE_ZERO)?-1:1)</span>
<a name="l00477"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#834d9d9a7b29b8869e96f85901244e94">00477</a> <span class="preprocessor"></span><span class="preprocessor">#define value_compare(v1,v2) (value_eq(v1,v2)?0:value_lt(v1,v2)?-1:1)</span>
<a name="l00478"></a>00478 <span class="preprocessor"></span>
<a name="l00479"></a>00479 <span class="comment">/* Binary operators on 'Value' */</span>
<a name="l00480"></a>00480 
<a name="l00481"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#cae2d8e9e70a1e0345341501fa4ba85b">00481</a> <span class="preprocessor">#define value_plus(v1,v2)               ((v1)+(v2))</span>
<a name="l00482"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#f0c0495c1d7f12ba2b8043b9c411e8f3">00482</a> <span class="preprocessor"></span><span class="preprocessor">#define value_div(v1,v2)                ((v1)/(v2))</span>
<a name="l00483"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#d7cf303909e10b8b5aab7fcf5fb46653">00483</a> <span class="preprocessor"></span><span class="preprocessor">#define value_mod(v1,v2)                ((v1)%(v2))</span>
<a name="l00484"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#637344db42ed7b60825d7feb491db59c">00484</a> <span class="preprocessor"></span><span class="preprocessor">#define value_direct_multiply(v1,v2)    ((v1)*(v2)) </span><span class="comment">/* direct! */</span>
<a name="l00485"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#101d6ca01d6ec5ebea6538b5f3f108bf">00485</a> <span class="preprocessor">#define value_minus(v1,v2)              ((v1)-(v2))</span>
<a name="l00486"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#4486138a30309d7ddc3a0d840f7bea44">00486</a> <span class="preprocessor"></span><span class="preprocessor">#define value_pdiv(v1,v2)               (DIVIDE((v1),(v2)))</span>
<a name="l00487"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#7afe5e45f608d26a094405cfe28396ad">00487</a> <span class="preprocessor"></span><span class="preprocessor">#define value_pmod(v1,v2)               (MODULO((v1),(v2)))</span>
<a name="l00488"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#1e944dfead7e89d5195b7c5c5ac1d756">00488</a> <span class="preprocessor"></span><span class="preprocessor">#define value_min(v1,v2)                (value_le((v1),(v2))? (v1): (v2))</span>
<a name="l00489"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#9150b225be957f307cb578241bcfd4a0">00489</a> <span class="preprocessor"></span><span class="preprocessor">#define value_max(v1,v2)                (value_ge((v1),(v2))? (v1): (v2))</span>
<a name="l00490"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#68fbeb59dc28a1792142d39c29c229c8">00490</a> <span class="preprocessor"></span><span class="preprocessor">#define value_or(v1,v2)                 ((v1)|(v2))</span>
<a name="l00491"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#b78567c31207e4bfaef1446b48ac72d1">00491</a> <span class="preprocessor"></span><span class="preprocessor">#define value_and(v1,v2)                ((v1)&amp;(v2))</span>
<a name="l00492"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#046b506f20238e83b2c984119c41ada7">00492</a> <span class="preprocessor"></span><span class="preprocessor">#define value_lshift(v1,v2)             ((v1)&lt;&lt;(v2))</span>
<a name="l00493"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#3a86334282502781248914cc93cbde9a">00493</a> <span class="preprocessor"></span><span class="preprocessor">#define value_rshift(v1,v2)             ((v1)&gt;&gt;(v2))</span>
<a name="l00494"></a>00494 <span class="preprocessor"></span>                                  
<a name="l00495"></a>00495 <span class="comment">/* Binary operations on 'Value' */</span> 
<a name="l00496"></a>00496 
<a name="l00497"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#ea216a0e750144f0e6eb9b0a82583739">00497</a> <span class="preprocessor">#define value_addto(ref,val1,val2)      ((ref) = (val1)+(val2))</span>
<a name="l00498"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#73e7093353d4108ea8f63898e868ed5f">00498</a> <span class="preprocessor"></span><span class="preprocessor">#define value_add_int(ref,val,vint)     ((ref) = (val)+(Value)(vint))</span>
<a name="l00499"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#9900fbd029b36f5887e587642a064a52">00499</a> <span class="preprocessor"></span><span class="preprocessor">#define value_addmul(ref, val1, val2)   ((ref) += (val1)*(val2))</span>
<a name="l00500"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#88693f35dd41deddc6ac0700073fc8db">00500</a> <span class="preprocessor"></span><span class="preprocessor">#define value_increment(ref,val)        ((ref) = (val)+VALUE_ONE)</span>
<a name="l00501"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#688566888224948b43fe88266d4824b0">00501</a> <span class="preprocessor"></span><span class="preprocessor">#define value_direct_product(ref,val1,val2) ((ref) = (val1)*(val2)) </span><span class="comment">/* direct! */</span>
<a name="l00502"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#c9986d34264874727344f666079e2294">00502</a> <span class="preprocessor">#define value_multiply(ref,val1,val2)   ((ref) = value_mult((val1),(val2)))</span>
<a name="l00503"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#e92a58eee3b6f5c6a99e6837e68407e1">00503</a> <span class="preprocessor"></span><span class="preprocessor">#define value_subtract(ref,val1,val2)   ((ref) = (val1)-(val2))</span>
<a name="l00504"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#11f18b25f757ecabd62ef14833909101">00504</a> <span class="preprocessor"></span><span class="preprocessor">#define value_sub_int(ref,val,vint)     ((ref) = (val)-(Value)(vint))</span>
<a name="l00505"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#7e293e9652086118cc5b660e6022767c">00505</a> <span class="preprocessor"></span><span class="preprocessor">#define value_decrement(ref,val)        ((ref) = (val)-VALUE_ONE)</span>
<a name="l00506"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#c633e4bcd9ed1d8412c67cda6d8ddb11">00506</a> <span class="preprocessor"></span><span class="preprocessor">#define value_division(ref,val1,val2)   ((ref) = (val1)/(val2))</span>
<a name="l00507"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#4b01d50506e0c7691b69d57a87280f5d">00507</a> <span class="preprocessor"></span><span class="preprocessor">#define value_divexact(ref,val1,val2)   ((ref) = (val1)/(val2))</span>
<a name="l00508"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#e77f928488d756f77270649775dbdc1d">00508</a> <span class="preprocessor"></span><span class="preprocessor">#define value_modulus(ref,val1,val2)    ((ref) = (val1)%(val2))</span>
<a name="l00509"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#1d5fd16549d53f259c2e7699a22045cb">00509</a> <span class="preprocessor"></span><span class="preprocessor">#define value_pdivision(ref,val1,val2)  ((ref) = value_pdiv((val1),(val2)))</span>
<a name="l00510"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#60a1720f53f9951170f929062609ddcf">00510</a> <span class="preprocessor"></span><span class="preprocessor">#define value_pmodulus(ref,val1,val2)   ((ref) = value_pmod((val1),(val2)))</span>
<a name="l00511"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#0daf9a8ecdc14e7a274832b0d2add830">00511</a> <span class="preprocessor"></span><span class="preprocessor">#define value_oppose(ref,val)           ((ref) = value_uminus((val)))</span>
<a name="l00512"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#6eee595d027bdf64a6c529b5f138720f">00512</a> <span class="preprocessor"></span><span class="preprocessor">#define value_absolute(ref,val)         ((ref) = value_abs((val)))</span>
<a name="l00513"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#9fbcdc6197a1265592e07971b96697c1">00513</a> <span class="preprocessor"></span><span class="preprocessor">#define value_minimum(ref,val1,val2)    ((ref) = value_min((val1),(val2)))</span>
<a name="l00514"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#16c10b8c252986ace3112e0e29806862">00514</a> <span class="preprocessor"></span><span class="preprocessor">#define value_maximum(ref,val1,val2)    ((ref) = value_max((val1),(val2)))</span>
<a name="l00515"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#50a34e78517e58cd1c2494a99be1e62b">00515</a> <span class="preprocessor"></span><span class="preprocessor">#define value_gcd(ref,val1,val2)        Gcd((val1),(val2),&amp;(ref))</span>
<a name="l00516"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#6da13dbfdd065b7609591ff6b3aee310">00516</a> <span class="preprocessor"></span><span class="preprocessor">#define value_lcm(ref,val1,val2)        Lcm3((val1),(val2),&amp;(ref))</span>
<a name="l00517"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#1f761530f8c361092deeec7c0bb5550b">00517</a> <span class="preprocessor"></span><span class="preprocessor">#define value_orto(ref,val1,val2)       ((ref) = (val1)|(val2))</span>
<a name="l00518"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#49248690f68da42b3cad7be17be3d334">00518</a> <span class="preprocessor"></span><span class="preprocessor">#define value_andto(ref,val1,val2)      ((ref) = (val1)&amp;(val2))</span>
<a name="l00519"></a>00519 <span class="preprocessor"></span>
<a name="l00520"></a>00520 <span class="comment">/* Unary operators on 'Value' */</span>
<a name="l00521"></a>00521 
<a name="l00522"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#576870137174189d4db56c67726c0801">00522</a> <span class="preprocessor">#define value_uminus(val)  (-(val))</span>
<a name="l00523"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#671cd08d768f8465ac65cf15aa02bcf2">00523</a> <span class="preprocessor"></span><span class="preprocessor">#define value_not(val)  (~(val))</span>
<a name="l00524"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#cd3394545531e41bbb6894f80789e998">00524</a> <span class="preprocessor"></span><span class="preprocessor">#define value_abs(val) (value_posz_p(val)? \</span>
<a name="l00525"></a>00525 <span class="preprocessor">    (val) :                                \</span>
<a name="l00526"></a>00526 <span class="preprocessor">    (value_ne((val), VALUE_NAN) ?          \</span>
<a name="l00527"></a>00527 <span class="preprocessor">     value_uminus(val) :                   \</span>
<a name="l00528"></a>00528 <span class="preprocessor">    (THROW (overflow_error), VALUE_NAN )))</span>
<a name="l00529"></a>00529 <span class="preprocessor"></span>
<a name="l00530"></a>00530 <span class="comment">/* Conditional operations on 'Value' */</span>
<a name="l00531"></a>00531 
<a name="l00532"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#01904c8c75c10d407a24c55f16ec27c7">00532</a> <span class="preprocessor">#define value_pos_p(val)      value_gt(val,VALUE_ZERO)</span>
<a name="l00533"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#f031da52c8a160fd1ee6e4c793f8c78a">00533</a> <span class="preprocessor"></span><span class="preprocessor">#define value_neg_p(val)      value_lt(val,VALUE_ZERO)</span>
<a name="l00534"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#fef45b8b369740e71140484a097b6ab4">00534</a> <span class="preprocessor"></span><span class="preprocessor">#define value_posz_p(val)     value_ge(val,VALUE_ZERO)</span>
<a name="l00535"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#61e2f80c3eee5c7453a805bc1b0b501a">00535</a> <span class="preprocessor"></span><span class="preprocessor">#define value_negz_p(val)     value_le(val,VALUE_ZERO)</span>
<a name="l00536"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#827532f2140ae2aa96e46baebae09723">00536</a> <span class="preprocessor"></span><span class="preprocessor">#define value_zero_p(val)     value_eq(val,VALUE_ZERO)</span>
<a name="l00537"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#47d32925340d2dc99ef2d4215080a60d">00537</a> <span class="preprocessor"></span><span class="preprocessor">#define value_notzero_p(val)  value_ne(val,VALUE_ZERO)</span>
<a name="l00538"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#61db0ba9ba925615ec70eb92e40b9ef4">00538</a> <span class="preprocessor"></span><span class="preprocessor">#define value_one_p(val)      value_eq(val,VALUE_ONE)</span>
<a name="l00539"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#5f258141f9e07b66da01ff7f4fe3d56d">00539</a> <span class="preprocessor"></span><span class="preprocessor">#define value_notone_p(val)   value_ne(val,VALUE_ONE)</span>
<a name="l00540"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#0a56519397244e2bc48e480bcd2f2a63">00540</a> <span class="preprocessor"></span><span class="preprocessor">#define value_mone_p(val)     value_eq(val,VALUE_MONE)</span>
<a name="l00541"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#9c79acd9dc1cf8e9cddc5fe64dc4c5c0">00541</a> <span class="preprocessor"></span><span class="preprocessor">#define value_notmone_p(val)  value_ne(val,VALUE_MONE)</span>
<a name="l00542"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#fee537d2d3f20ba6a656fe84ce54c6ce">00542</a> <span class="preprocessor"></span><span class="preprocessor">#define value_cmp_si(val, n)  (val - (n))</span>
<a name="l00543"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#7e3dc8221fc165483e523ad449c84d62">00543</a> <span class="preprocessor"></span><span class="preprocessor">#define value_min_p(val)      value_eq(val,VALUE_MIN)</span>
<a name="l00544"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#c92083fca0b20b8a1994078d8976d181">00544</a> <span class="preprocessor"></span><span class="preprocessor">#define value_max_p(val)      value_eq(val,VALUE_MAX)</span>
<a name="l00545"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#56f6bb3d8111a25a4acdffc9084e9302">00545</a> <span class="preprocessor"></span><span class="preprocessor">#define value_notmin_p(val)   value_ne(val,VALUE_MIN)</span>
<a name="l00546"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#8894a5e8fdbbd5eb95570c8ee802f7e4">00546</a> <span class="preprocessor"></span><span class="preprocessor">#define value_notmax_p(val)   value_ne(val,VALUE_MAX)</span>
<a name="l00547"></a>00547 <span class="preprocessor"></span>
<a name="l00548"></a>00548 <span class="preprocessor">#endif </span><span class="comment">/* 'Value' set to |longlong|long|float|char *|int */</span>
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a>00551 <span class="comment">/* *********************** PROTECTED MULTIPLICATION ********************** */</span>
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 <span class="preprocessor">#include "<a class="code" href="include_2polylib_2arithmetic__errors_8h.html">arithmetic_errors.h</a>"</span>
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 <span class="comment">/* (|v| &lt; MAX / |w|) =&gt; v*w is okay</span>
<a name="l00556"></a>00556 <span class="comment"> * I could check ((v*w)/w)==v but a tmp would be useful</span>
<a name="l00557"></a>00557 <span class="comment"> */</span>
<a name="l00558"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#1c7ef01130fdeaf77fa259298e6cfbe9">00558</a> <span class="preprocessor">#define value_protected_hard_idiv_multiply(v,w,throw)           \</span>
<a name="l00559"></a>00559 <span class="preprocessor">  ((value_zero_p(w) || value_zero_p(v))? VALUE_ZERO:            \</span>
<a name="l00560"></a>00560 <span class="preprocessor">   value_lt(value_abs(v),value_div(VALUE_MAX,value_abs(w)))?    \</span>
<a name="l00561"></a>00561 <span class="preprocessor">   value_direct_multiply(v,w): (throw, VALUE_NAN))</span>
<a name="l00562"></a>00562 <span class="preprocessor"></span>
<a name="l00563"></a>00563 <span class="comment">/* is a software idiv is assumed, quick check performed first</span>
<a name="l00564"></a>00564 <span class="comment"> */</span>
<a name="l00565"></a>00565 <span class="preprocessor">#if defined(LINEAR_VALUE_ASSUME_SOFTWARE_IDIV)</span>
<a name="l00566"></a>00566 <span class="preprocessor"></span><span class="preprocessor">#define value_protected_multiply(v,w,throw)                                   \</span>
<a name="l00567"></a>00567 <span class="preprocessor">  ((value_le(v,VALUE_SQRT_MAX) &amp;&amp; value_le(w,VALUE_SQRT_MAX) &amp;&amp;               \</span>
<a name="l00568"></a>00568 <span class="preprocessor">   value_ge(v,VALUE_SQRT_MIN) &amp;&amp; value_ge(w,VALUE_SQRT_MIN))?                 \</span>
<a name="l00569"></a>00569 <span class="preprocessor">   value_direct_multiply(v,w): value_protected_hard_idiv_multiply(v,w,throw))</span>
<a name="l00570"></a>00570 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00571"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#11a8d0cbdc0ad53e4397a23812dbaf28">00571</a> <span class="preprocessor"></span><span class="preprocessor">#define value_protected_multiply(v,w,throw)             \</span>
<a name="l00572"></a>00572 <span class="preprocessor">   value_protected_hard_idiv_multiply(v,w,throw)</span>
<a name="l00573"></a>00573 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00574"></a>00574 <span class="preprocessor"></span>
<a name="l00575"></a>00575 <span class="comment">/* protected versions</span>
<a name="l00576"></a>00576 <span class="comment"> */</span>
<a name="l00577"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#6cd46001197fe41d3d661abf3f98c5d2">00577</a> <span class="preprocessor">#define value_protected_mult(v,w)                               \</span>
<a name="l00578"></a>00578 <span class="preprocessor">    value_protected_multiply(v,w,THROW(overflow_error))</span>
<a name="l00579"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#a2b8ff13d3d30810bb899a2b73bc4e54">00579</a> <span class="preprocessor"></span><span class="preprocessor">#define value_protected_product(v,w)            \</span>
<a name="l00580"></a>00580 <span class="preprocessor">    v=value_protected_mult(v,w)</span>
<a name="l00581"></a>00581 <span class="preprocessor"></span>
<a name="l00582"></a>00582 <span class="comment">/* whether the default is protected or not </span>
<a name="l00583"></a>00583 <span class="comment"> * this define makes no sense any more... well, doesn't matter. FC.</span>
<a name="l00584"></a>00584 <span class="comment"> */</span>
<a name="l00585"></a>00585 <span class="preprocessor">#if defined(LINEAR_VALUE_PROTECT_MULTIPLY)</span>
<a name="l00586"></a>00586 <span class="preprocessor"></span><span class="preprocessor">#define value_mult(v,w) value_protected_mult(v,w)</span>
<a name="l00587"></a>00587 <span class="preprocessor"></span><span class="preprocessor">#define value_product(v,w) value_protected_product(v,w)</span>
<a name="l00588"></a>00588 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00589"></a>00589 <span class="preprocessor"></span>
<a name="l00590"></a>00590 <span class="comment">/* I do enforce the protection whatever requested:-)</span>
<a name="l00591"></a>00591 <span class="comment"> * prints out a message and throws the exception, hoping</span>
<a name="l00592"></a>00592 <span class="comment"> * that some valid CATCH waits for it upwards. </span>
<a name="l00593"></a>00593 <span class="comment"> */</span>
<a name="l00594"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#d5d408652537e157597d6d74dfdbcfed">00594</a> <span class="preprocessor">#define value_mult(v,w)                                                       \</span>
<a name="l00595"></a>00595 <span class="preprocessor">  value_protected_multiply(v,w,                                               \</span>
<a name="l00596"></a>00596 <span class="preprocessor">    (fprintf(stderr,"[value_mult] value overflow!\n"),THROW(overflow_error)))</span>
<a name="l00597"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#c99946251be9c46e672cd9c860b81c2d">00597</a> <span class="preprocessor"></span><span class="preprocessor">#define value_product(v,w) v=value_mult(v,w)</span>
<a name="l00598"></a>00598 <span class="preprocessor"></span>
<a name="l00599"></a>00599 <span class="comment">/* was:</span>
<a name="l00600"></a>00600 <span class="comment"> * #define value_mult(v,w) value_direct_multiply(v,w)</span>
<a name="l00601"></a>00601 <span class="comment"> * #define value_product(v,w) value_direct_product(v,w)</span>
<a name="l00602"></a>00602 <span class="comment"> * could be: protected versions...</span>
<a name="l00603"></a>00603 <span class="comment"> */</span>
<a name="l00604"></a>00604 <span class="preprocessor">#endif</span>
<a name="l00605"></a>00605 <span class="preprocessor"></span>
<a name="l00606"></a>00606 <span class="comment">/******************************************************* STATIC VALUE DEBUG */</span>
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 <span class="comment">/* LINEAR_VALUE_IS_CHARS is used for type checking.</span>
<a name="l00609"></a>00609 <span class="comment"> * some operations are not allowed on (char*), thus</span>
<a name="l00610"></a>00610 <span class="comment"> * they are switched to some other operation here...</span>
<a name="l00611"></a>00611 <span class="comment"> */</span>
<a name="l00612"></a>00612 <span class="preprocessor">#if defined(LINEAR_VALUE_IS_CHARS)</span>
<a name="l00613"></a>00613 <span class="preprocessor"></span><span class="preprocessor">#define value_fake_binary(v1,v2) ((Value)((v1).i+(v2).i))</span>
<a name="l00614"></a>00614 <span class="preprocessor"></span><span class="preprocessor">#define value_bool_binary(v1,v2) ((int)((v1).i+(v2).i))</span>
<a name="l00615"></a>00615 <span class="preprocessor"></span><span class="preprocessor">#undef float_to_value</span>
<a name="l00616"></a>00616 <span class="preprocessor"></span><span class="preprocessor">#define float_to_value(f) ((Value)f)</span>
<a name="l00617"></a>00617 <span class="preprocessor"></span><span class="preprocessor">#undef double_to_value</span>
<a name="l00618"></a>00618 <span class="preprocessor"></span><span class="preprocessor">#define double_to_value(f) ((Value)f)</span>
<a name="l00619"></a>00619 <span class="preprocessor"></span><span class="preprocessor">#undef value_uminus</span>
<a name="l00620"></a>00620 <span class="preprocessor"></span><span class="preprocessor">#define value_uminus(v) (v)</span>
<a name="l00621"></a>00621 <span class="preprocessor"></span><span class="preprocessor">#undef value_mult</span>
<a name="l00622"></a>00622 <span class="preprocessor"></span><span class="preprocessor">#define value_mult(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00623"></a>00623 <span class="preprocessor"></span><span class="preprocessor">#undef value_mod</span>
<a name="l00624"></a>00624 <span class="preprocessor"></span><span class="preprocessor">#define value_mod(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00625"></a>00625 <span class="preprocessor"></span><span class="preprocessor">#undef value_ge</span>
<a name="l00626"></a>00626 <span class="preprocessor"></span><span class="preprocessor">#define value_ge(v1,v2) value_bool_binary(v1,v2)</span>
<a name="l00627"></a>00627 <span class="preprocessor"></span><span class="preprocessor">#undef value_gt</span>
<a name="l00628"></a>00628 <span class="preprocessor"></span><span class="preprocessor">#define value_gt(v1,v2) value_bool_binary(v1,v2)</span>
<a name="l00629"></a>00629 <span class="preprocessor"></span><span class="preprocessor">#undef value_le</span>
<a name="l00630"></a>00630 <span class="preprocessor"></span><span class="preprocessor">#define value_le(v1,v2) value_bool_binary(v1,v2)</span>
<a name="l00631"></a>00631 <span class="preprocessor"></span><span class="preprocessor">#undef value_lt</span>
<a name="l00632"></a>00632 <span class="preprocessor"></span><span class="preprocessor">#define value_lt(v1,v2) value_bool_binary(v1,v2)</span>
<a name="l00633"></a>00633 <span class="preprocessor"></span><span class="preprocessor">#undef value_ne</span>
<a name="l00634"></a>00634 <span class="preprocessor"></span><span class="preprocessor">#define value_ne(v1,v2) value_bool_binary(v1,v2)</span>
<a name="l00635"></a>00635 <span class="preprocessor"></span><span class="preprocessor">#undef value_eq</span>
<a name="l00636"></a>00636 <span class="preprocessor"></span><span class="preprocessor">#define value_eq(v1,v2) value_bool_binary(v1,v2)</span>
<a name="l00637"></a>00637 <span class="preprocessor"></span><span class="preprocessor">#undef value_plus</span>
<a name="l00638"></a>00638 <span class="preprocessor"></span><span class="preprocessor">#define value_plus(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00639"></a>00639 <span class="preprocessor"></span><span class="preprocessor">#undef value_minus</span>
<a name="l00640"></a>00640 <span class="preprocessor"></span><span class="preprocessor">#define value_minus(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00641"></a>00641 <span class="preprocessor"></span><span class="preprocessor">#undef value_pdiv</span>
<a name="l00642"></a>00642 <span class="preprocessor"></span><span class="preprocessor">#define value_pdiv(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00643"></a>00643 <span class="preprocessor"></span><span class="preprocessor">#undef value_div</span>
<a name="l00644"></a>00644 <span class="preprocessor"></span><span class="preprocessor">#define value_div(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00645"></a>00645 <span class="preprocessor"></span><span class="preprocessor">#undef value_mod</span>
<a name="l00646"></a>00646 <span class="preprocessor"></span><span class="preprocessor">#define value_mod(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00647"></a>00647 <span class="preprocessor"></span><span class="preprocessor">#undef value_addto</span>
<a name="l00648"></a>00648 <span class="preprocessor"></span><span class="preprocessor">#define value_addto(v1,v2) value_assign(v1,value_plus(v1,v2))</span>
<a name="l00649"></a>00649 <span class="preprocessor"></span><span class="preprocessor">#undef value_subtract</span>
<a name="l00650"></a>00650 <span class="preprocessor"></span><span class="preprocessor">#define value_subtract(v1,v2) value_addto(v1,v2)</span>
<a name="l00651"></a>00651 <span class="preprocessor"></span><span class="preprocessor">#undef value_product</span>
<a name="l00652"></a>00652 <span class="preprocessor"></span><span class="preprocessor">#define value_product(v1,v2) value_addto(v1,v2)</span>
<a name="l00653"></a>00653 <span class="preprocessor"></span><span class="preprocessor">#undef value_modulus</span>
<a name="l00654"></a>00654 <span class="preprocessor"></span><span class="preprocessor">#define value_modulus(v1,v2) value_addto(v1,v2)</span>
<a name="l00655"></a>00655 <span class="preprocessor"></span><span class="preprocessor">#undef value_division</span>
<a name="l00656"></a>00656 <span class="preprocessor"></span><span class="preprocessor">#define value_division(v1,v2) value_addto(v1,v2)</span>
<a name="l00657"></a>00657 <span class="preprocessor"></span><span class="preprocessor">#undef value_divexact</span>
<a name="l00658"></a>00658 <span class="preprocessor"></span><span class="preprocessor">#define value_divexact(v1,v2) value_addto(v1,v2)</span>
<a name="l00659"></a>00659 <span class="preprocessor"></span><span class="preprocessor">#undef value_increment</span>
<a name="l00660"></a>00660 <span class="preprocessor"></span><span class="preprocessor">#define value_increment(v) value_addto(v,VALUE_ONE)</span>
<a name="l00661"></a>00661 <span class="preprocessor"></span><span class="preprocessor">#undef value_decrement</span>
<a name="l00662"></a>00662 <span class="preprocessor"></span><span class="preprocessor">#define value_decrement(v) value_addto(v,VALUE_MONE)</span>
<a name="l00663"></a>00663 <span class="preprocessor"></span><span class="preprocessor">#undef value_orto</span>
<a name="l00664"></a>00664 <span class="preprocessor"></span><span class="preprocessor">#define value_orto(ref,val) value_addto(v1,v2)</span>
<a name="l00665"></a>00665 <span class="preprocessor"></span><span class="preprocessor">#undef value_andto</span>
<a name="l00666"></a>00666 <span class="preprocessor"></span><span class="preprocessor">#define value_andto(ref,val) value_addto(v1,v2) </span>
<a name="l00667"></a>00667 <span class="preprocessor"></span><span class="preprocessor">#undef value_or</span>
<a name="l00668"></a>00668 <span class="preprocessor"></span><span class="preprocessor">#define value_or(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00669"></a>00669 <span class="preprocessor"></span><span class="preprocessor">#undef value_and</span>
<a name="l00670"></a>00670 <span class="preprocessor"></span><span class="preprocessor">#define value_and(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00671"></a>00671 <span class="preprocessor"></span><span class="preprocessor">#undef value_lshift</span>
<a name="l00672"></a>00672 <span class="preprocessor"></span><span class="preprocessor">#define value_lshift(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00673"></a>00673 <span class="preprocessor"></span><span class="preprocessor">#undef value_rshift</span>
<a name="l00674"></a>00674 <span class="preprocessor"></span><span class="preprocessor">#define value_rshift(v1,v2) value_fake_binary(v1,v2)</span>
<a name="l00675"></a>00675 <span class="preprocessor"></span><span class="preprocessor">#endif </span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>
<a name="l00677"></a>00677 <span class="comment">/* for backward compatibility */</span>
<a name="l00678"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#6a99f2631bbedb9d97e9b39231dd4136">00678</a> <span class="preprocessor">#define value_substract(ref,val1,val2) (value_subtract((ref),(val1),(val2)))</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span>
<a name="l00680"></a>00680 <span class="comment">/* valeur absolue</span>
<a name="l00681"></a>00681 <span class="comment"> */</span>
<a name="l00682"></a>00682 <span class="preprocessor">#ifndef ABS</span>
<a name="l00683"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#996f7be338ccb40d1a2a5abc1ad61759">00683</a> <span class="preprocessor"></span><span class="preprocessor">#define ABS(x) (((x)&gt;=0) ? (x) : -(x))</span>
<a name="l00684"></a>00684 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00685"></a>00685 <span class="preprocessor"></span>
<a name="l00686"></a>00686 <span class="comment">/* minimum et maximum </span>
<a name="l00687"></a>00687 <span class="comment"> * if they are defined somewhere else, they are very likely </span>
<a name="l00688"></a>00688 <span class="comment"> * to be defined the same way. Thus the previous def is not overwritten.</span>
<a name="l00689"></a>00689 <span class="comment"> */</span>
<a name="l00690"></a>00690 <span class="preprocessor">#ifndef MIN</span>
<a name="l00691"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#74e75242132eaabbc1c512488a135926">00691</a> <span class="preprocessor"></span><span class="preprocessor">#define MIN(x,y) (((x)&gt;=(y))?(y):(x))</span>
<a name="l00692"></a>00692 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00693"></a>00693 <span class="preprocessor"></span><span class="preprocessor">#ifndef MAX</span>
<a name="l00694"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#acc3ee1a7f283f8ef65cea31f4436a95">00694</a> <span class="preprocessor"></span><span class="preprocessor">#define MAX(x,y) (((x)&gt;=(y))?(x):(y))</span>
<a name="l00695"></a>00695 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00696"></a>00696 <span class="preprocessor"></span>
<a name="l00697"></a>00697 <span class="comment">/* signe d'un entier: -1, 0 ou 1 */</span>
<a name="l00698"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#8c5ff70b6b28cd0157c50a22406f92c4">00698</a> <span class="preprocessor">#define SIGN(x) (((x)&gt;0)? 1 : ((x)==0? 0 : -1))</span>
<a name="l00699"></a>00699 <span class="preprocessor"></span>
<a name="l00700"></a>00700 <span class="comment">/* division avec reste toujours positif</span>
<a name="l00701"></a>00701 <span class="comment"> * basee sur les equations:</span>
<a name="l00702"></a>00702 <span class="comment"> * a/(-b) = - (a/b)</span>
<a name="l00703"></a>00703 <span class="comment"> * (-a)/b = - ((a+b-1)/b)</span>
<a name="l00704"></a>00704 <span class="comment"> * ou a et b sont des entiers positifs</span>
<a name="l00705"></a>00705 <span class="comment"> */</span>
<a name="l00706"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#0f6543a5e0f04f740d7823465a151da6">00706</a> <span class="preprocessor">#define DIVIDE(x,y) ((y)&gt;0? POSITIVE_DIVIDE(x,y) : \</span>
<a name="l00707"></a>00707 <span class="preprocessor">                     -POSITIVE_DIVIDE((x),(-(y))))</span>
<a name="l00708"></a>00708 <span class="preprocessor"></span>
<a name="l00709"></a>00709 <span class="comment">/* division avec reste toujours positif quand y est positif: assert(y&gt;=0) */</span>
<a name="l00710"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#eb0ec36087e77c26acdf6d120fbb57d2">00710</a> <span class="preprocessor">#define POSITIVE_DIVIDE(x,y) ((x)&gt;0 ? (x)/(y) : - (-(x)+(y)-1)/(y))</span>
<a name="l00711"></a>00711 <span class="preprocessor"></span>
<a name="l00712"></a>00712 <span class="comment">/* modulo a resultat toujours positif */</span>
<a name="l00713"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#6c8409e689ef27a4ea2bcf0f705afa46">00713</a> <span class="preprocessor">#define MODULO(x,y) ((y)&gt;0 ? POSITIVE_MODULO(x,y) : POSITIVE_MODULO(-x,-y))</span>
<a name="l00714"></a>00714 <span class="preprocessor"></span>
<a name="l00715"></a>00715 <span class="comment">/* modulo par rapport a un nombre positif: assert(y&gt;=0)</span>
<a name="l00716"></a>00716 <span class="comment"> *</span>
<a name="l00717"></a>00717 <span class="comment"> * Ce n'est pas la macro la plus efficace que j'aie jamais ecrite: il faut</span>
<a name="l00718"></a>00718 <span class="comment"> * faire, dans le pire des cas, deux appels a la routine .rem, qui n'est</span>
<a name="l00719"></a>00719 <span class="comment"> * surement pas plus cablee que la division ou la multiplication</span>
<a name="l00720"></a>00720 <span class="comment"> */</span>
<a name="l00721"></a><a class="code" href="include_2polylib_2arithmetique_8h.html#7901668879676973ca155e170cac7b78">00721</a> <span class="preprocessor">#define POSITIVE_MODULO(x,y) ((x) &gt; 0 ? (x)%(y) : \</span>
<a name="l00722"></a>00722 <span class="preprocessor">                              ((x)%(y) == 0 ? 0 : ((y)-(-(x))%(y))))</span>
<a name="l00723"></a>00723 <span class="preprocessor"></span>                              
<a name="l00724"></a>00724 <span class="comment">/* errors.c */</span> 
<a name="l00725"></a>00725 <span class="keyword">extern</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="source_2arith_2arithmetique_8h.html#f74135a8750c28205f819842ae8be9c9">overflow_error</a>;
<a name="l00726"></a>00726 <span class="keyword">extern</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="source_2arith_2arithmetique_8h.html#381d67b7ee03ff84c242d6f342fa063c">simplex_arithmetic_error</a>;
<a name="l00727"></a>00727 <span class="keyword">extern</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="source_2arith_2arithmetique_8h.html#18b35523d2702706b86f2ab8ae2393d2">user_exception_error</a>;
<a name="l00728"></a>00728 <span class="keyword">extern</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="source_2arith_2arithmetique_8h.html#3806d9a2c0134fd8bef8c192341a8954">parser_exception_error</a>;
<a name="l00729"></a>00729 <span class="keyword">extern</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="source_2arith_2arithmetique_8h.html#3fbedc713824754a33dd94278851fe70">any_exception_error</a>; 
<a name="l00730"></a>00730 <span class="keyword">extern</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="source_2arith_2arithmetic__errors_8h.html#9dbd1094abce0128b2995c91d701349d">the_last_just_thrown_exception</a>;
<a name="l00731"></a>00731 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="source_2arith_2arithmetique_8h.html#95032703f9a53198ae5f188a05836557">dump_exception_stack_to_file</a>(FILE * <span class="comment">/*f*/</span>);
<a name="l00732"></a>00732 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="source_2arith_2arithmetique_8h.html#5d0d562c4394d6711b3d105487cfa229">dump_exception_stack</a>(<span class="keywordtype">void</span>);
<a name="l00733"></a>00733 <span class="keyword">extern</span> jmp_buf *<a class="code" href="source_2arith_2arithmetique_8h.html#6c4868122de3ac9f2dddafc35d583021">push_exception_on_stack</a>(<span class="keywordtype">int</span> <span class="comment">/*what*/</span>, <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="comment">/*function*/</span>, <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="comment">/*file*/</span>, <span class="keywordtype">int</span> <span class="comment">/*line*/</span>);
<a name="l00734"></a>00734 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="source_2arith_2arithmetique_8h.html#66795100cf9a30f6cf85a7c67d7c8050">pop_exception_from_stack</a>(<span class="keywordtype">int</span> <span class="comment">/*what*/</span>, <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="comment">/*function*/</span>, <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="comment">/*file*/</span>, <span class="keywordtype">int</span> <span class="comment">/*line*/</span>);
<a name="l00735"></a>00735 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="source_2arith_2arithmetique_8h.html#904f0eb5107e737736e3992a6c0dc90f">throw_exception</a>(<span class="keywordtype">int</span> <span class="comment">/*what*/</span>, <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="comment">/*function*/</span>, <span class="keyword">const</span> <span class="keywordtype">char</span> * <span class="comment">/*file*/</span>, <span class="keywordtype">int</span> <span class="comment">/*line*/</span>);
<a name="l00736"></a>00736 
<a name="l00737"></a>00737 <span class="preprocessor">#endif </span><span class="comment">/* arithmetique_header_included */</span>
<a name="l00738"></a>00738 
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 15 18:33:58 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.6 </small></address>
</body>
</html>
